import 'dart:io';

import 'package:flutter/material.dart';
import 'package:transmedika_one_to_one_call/webrtc/one_to_one_page.dart';
import 'package:transmedika_one_to_one_call/webrtc/profile.dart';


class MyHttpOverrides extends HttpOverrides {
  @override
  HttpClient createHttpClient(SecurityContext? context){
    return super.createHttpClient(context)
      ..badCertificateCallback = (X509Certificate cert, String host, int port)=> true;
  }
}

void main() {
  HttpOverrides.global = MyHttpOverrides();
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});
  @override
  Widget build(BuildContext context) {

    Profile mySelf = Profile(
        email: "maman@rskp.com",
        name: 'TN, MAMAN',
        uuid: '7bfb1588-fc6a-4878-a96f-126cd6a6692c',
        profilePicture: null
    );

    Profile other = Profile(
        email: "dion@rskp.com",
        name: 'dr. Dionisius Panji Wijanarko, Sp.B',
        uuid: '42c6145f-8143-4d67-ad30-6f84571e0f65',
        profilePicture: null
    );

    String consultationId = '224';

    /// Fcm token bisa kamu dapat dari request GET ke endpoint ini auth/check-device-id-multiple,
    /// Fcm token hanya digunakan jika kamu ingin menelepon saja, jadi optional
    /// OneToOneScreen(
    ///    mySelf: mySelf,
    ///    other: other,
    ///    consultationId: consultationId,
    ///    fcmTokens: fcmTokens
    ///  )
    List<String> fcmTokens = ['fYSu5ILSvcKFUwyPRo--kl:APA91bF7c3EVBX7jvGvhQZrFC-Y2t83sjZ79gljq03WE9finRILE608KHAZkrX0MRIjAZL2Fi2Cvy1orZY8C9sgNfTH_eHWJl0X7quGSyusbTDaCnwVtGuwT22H3PbQwhaPmAXgqX6Oq'];


    /// untuk menerima panggilan kamu cukup isi paramter construktor
    /// OneToOneScreen(
    ///    mySelf: mySelf,
    ///    other: other,
    ///    consultationId: consultationId
    ///  )
    /// untuk menerima panggilan mekanismenya aplikasi kamu akan menerima notifikasi, data myself, other, consultationId bisa kamu dapatkan
    /// dari data yang dikirim lewat notifikasi


    return MaterialApp(
        title: 'Flutter Demo',
        theme: ThemeData(
          primarySwatch: Colors.blue,
        ),
        home: OneToOneScreen(
            mySelf: mySelf,
            other: other,
            consultationId: consultationId,
            fcmTokens: fcmTokens
        )
    );
  }
}