import 'package:json_annotation/json_annotation.dart';
import 'package:transmedika_one_to_one_call/webrtc/fcm.dart';

part 'call_push_param.g.dart';

/// model for call ///
@JsonSerializable()
class CallPushParam{
  @JsonKey(name: 'id')
  final String id;

  @JsonKey(name: 'from')
  final String from;

  @JsonKey(name: 'to')
  final String to;

  @JsonKey(name: 'fcm')
  final Fcm fcm;

  CallPushParam({required this.id, required this.from, required this.to, required this.fcm});

  factory CallPushParam.fromJson(Map<String, dynamic> json) => _$CallPushParamFromJson(json);

  Map<String, dynamic> toJson() => _$CallPushParamToJson(this);
}