import 'package:json_annotation/json_annotation.dart';
import 'package:transmedika_one_to_one_call/webrtc/registration_session.dart';

import 'candidate.dart';
part 'socket_response.g.dart';

/// model for mapping message from message web socket to this model ///
@JsonSerializable(includeIfNull: false)
class SocketResponse{
  @JsonKey(name: 'id')
  final String id;

  @JsonKey(name: 'response')
  final String? response;

  @JsonKey(name: 'sdpAnswer')
  final String? sdpAnswer;

  @JsonKey(name: 'candidate')
  final Candidate? candidate;

  @JsonKey(name: 'message')
  final String? message;

  @JsonKey(name: 'success')
  final bool? success;

  @JsonKey(name: 'from')
  final RegistrationSession? from;

  @JsonKey(name: 'name')
  final String? name;

  @JsonKey(name: 'registrationPayload')
  final RegistrationSession? registrationSession;

  SocketResponse({
    required this.id,
    this.response,
    this.sdpAnswer,
    this.candidate,
    this.message,
    this.success,
    this.from,
    this.name,
    this.registrationSession
  });

  factory SocketResponse.fromJson(Map<String, dynamic> json) => _$SocketResponseFromJson(json);

  Map<String, dynamic> toJson() => _$SocketResponseToJson(this);
}