// ignore: avoid_web_libraries_in_flutter
import 'dart:html' if (dart.library.io) 'dart:io';

import 'package:flutter/foundation.dart';
import 'package:transmedika_one_to_one_call/webrtc/websocket_service.dart';

/// implement class web socket for web
class SimpleWebSocket implements WebSocketService{
  String _url;
  late WebSocket _socket;
  @override
  Function()? onOpen;
  @override
  Function(dynamic msg)? onMessage;
  @override
  Function(int code, String reason)? onClose;

  SimpleWebSocket(this._url) {
    _url = _url.replaceAll('https:', 'wss:');
  }

  /// connect to web socket for web platform
  @override
  Future<void> connect() async {
    _socket = WebSocket(_url);
    _socket.onOpen.listen((e) {
      onOpen?.call();
    });

    _socket.onMessage.listen((e) {
      onMessage?.call(e.data);
    });

    _socket.onError.listen((e) {
      onClose?.call(500, e.toString());
    });

    _socket.onClose.listen((e) {
      onClose?.call(e.code!, (e.reason?.isEmpty == true ? "Socket was close":e.reason!));
    });
  }

  @override
  send(data) async {
    try{
      if (_socket.readyState == WebSocket.OPEN) {
        _socket.send(data);
        if (kDebugMode) {
          print('send: $data');
        }
      } else {
        if (kDebugMode) {
          print('WebSocket not connected, message $data not sent');
        }
      }
    }on Exception catch (e){
      if (kDebugMode) {
        print(e);
      }
    }
  }

  @override
  close() async {
    try{
      _socket.close();
    }on Exception catch (e) {
      if (kDebugMode) {
        print(e);
      }
    }
  }
}
